_ID = addMissionEventHandler ["Draw3D",{
	_veh = vehicle player;
	if (!isEngineOn _veh OR !alive _veh OR isNull driver _veh) exitWith {removeMissionEventHandler ["Draw3D",_thisEventHandler];};
	
	if (player isEqualTo _veh OR {!isTouchingGround _veh}) exitWith {false};

	_initMass = getMass _veh;
	
	_intake = _veh getVariable["Intake",1];
	_auspuff = _veh getVariable["Auspuff",1];
	_ecm = _veh getVariable["ECM",1];
	_zuendkerze = _veh getVariable["Zuendkerze",1];
	_motor = _veh getVariable["Motorblock",1];
	_turbo = _veh getVariable["Turbolader",1];
	_zylinder = _veh getVariable["Zylinder",1];
	_ansaugung = _veh getVariable["Ansaugung",1];
	
	_intakeb = 0;
	_auspuffb = 0;
	_ecmb = 0;
	_zuendkerzeb = 0;
	_motorb = 0;
	_turbob = 0;
	_zylinderb = 0;
	_ansaugungb = 0;	
	
	switch (_intake) do {
		case 1: {_intakeb = 0;};
		case 2: {_intakeb = 0.2;};
		case 3: {_intakeb = 0.3;};
		case 4: {_intakeb = 0.4;};
	};
	
	switch (_auspuff) do {
		case 1: {_auspuffb = 0;};
		case 2: {_auspuffb = 0.2;};
		case 3: {_auspuffb = 0.3;};
		case 4: {_auspuffb = 0.4;};
	};
	
	switch (_ecm) do {
		case 1: {_ecmb = 0;};
		case 2: {_ecmb = 0.2;};
		case 3: {_ecmb = 0.3;};
		case 4: {_ecmb = 0.4;};
	};
	
	switch (_zuendkerze) do {
		case 1: {_zuendkerzeb = 0;};
		case 2: {_zuendkerzeb = 0.2;};
		case 3: {_zuendkerzeb = 0.3;};
		case 4: {_zuendkerzeb = 0.4;};
	};
	
	switch (_motor) do {
		case 1: {_motorb = 0;};
		case 2: {_motorb = 0.2;};
		case 3: {_motorb = 0.3;};
		case 4: {_motorb = 0.4;};
	};
	
	switch (_turbo) do {
		case 1: {_turbob = 0;};
		case 2: {_turbob = 0.2;};
		case 3: {_turbob = 0.3;};
		case 4: {_turbob = 0.4;};
	};
	
	switch (_zylinder) do {
		case 1: {_zylinderb = 0;};
		case 2: {_zylinderb = 0.2;};
		case 3: {_zylinderb = 0.3;};
		case 4: {_zylinderb = 0.4;};
	};
	
	switch (_ansaugung) do {
		case 1: {_ansaugungb = 0;};
		case 2: {_ansaugungb = 0.2;};
		case 3: {_ansaugungb = 0.3;};
		case 4: {_ansaugungb = 0.4;};
	};
	
	_boostMulti = _intakeb + _auspuffb + _ecmb + _motorb + _turbob + _zylinderb + _zuendkerzeb + _ansaugungb;
	
	_force = (_initMass * (_boostMulti / 9)) max 0;
	_baseForce = _force;

	_maxSpeedMulti = _veh getvariable ["MaxSpeed",1];
	_maxSpeed = getNumber (configfile >> "CfgVehicles" >> typeOf _veh >>
	"maxSpeed") * _maxSpeedMulti;

	_prefersRoads = (getNumber (configfile >> "CfgVehicles" >> typeOf _veh >> "preferRoads") > 0);
	_isOnRoad = isOnRoad _veh;

	_forward = (["CarForward","CarFastForward","CarSlowForward"] findIf {inputAction _x > 0} >= 0);




	if (inputAction "CarSlowForward" > 0) then {

		_force = _baseForce * 0.25;

	};

	if (inputAction "CarForward" > 0) then {

		_force = _baseForce * 0.5;

	};

	if (inputAction "CarFastForward" > 0) then {

		_force = _baseForce;
		

	};



	_boost = inputAction "vehicleTurbo" > 0 AND _forward;
	//add nitro option here
	if (_boost) then {

		_force = _baseForce;

	};


	//surfaceCoefficient:
	_surf = (surfaceType getPosATLVisual _veh);
	_surfaceType = _surf select [1,count _surf];
	_surfaceCoef = getNumber (configfile >> "CfgSurfaces" >> _surfaceType >> "maxSpeedCoef");

	_force = _force * _surfaceCoef;

	//now we tie force to rpm:
	_idleRPM = getNumber (configfile >> "CfgVehicles" >> typeof _veh >> "idleRpm");
	_redRPM = getNumber (configfile >> "CfgVehicles" >> typeof _veh >> "redRpm");
	_currentRPM = _veh getSoundController "rpm";

	_force = linearConversion [_idleRPM,_redRPM,_currentRPM,_force / 3,_force,true];
	_rpmForce = _force;
	//also tie force to speed to emulate air resistance
	_force = linearConversion [100,_maxSpeed,speed _veh,_force,_force * 0.65,true];
	_airForce = _force;

	if (_forward AND round speed _veh > 0 AND round speed _veh <= _maxSpeed) then {
	_veh addForce [_veh vectorModelToWorldVisual [0,_force,0],[0,0,-1]];

	};

	if (inputAction "CarBack" > 0 AND speed _veh >= 1) then {
	_brakemulti = _veh getvariable ["Brakes",0];
	_brakeForce = -75 * _brakemulti;
	_veh addForce [_veh vectorModelToWorldVisual [0,_brakeForce,0],[0,0,-1]];

	};
	
	_down = _veh getVariable ["Grip",0];
	_dow	= (_initMass * (_down / 20));
	_veh addForce [_veh vectorModelToWorld [0,0,-_dow], [0,0,0]];

	//hintsilent format ["Boost Active: %1\nBase force: %2\nRPM force: %3\nAir+RPM force: %4\nForce applied: %5\nSurface Coef: %6",_boost,_baseForce,_rpmForce,_airForce,_force,_surfaceCoef];

	//blowOff valve

	_lastFrameRPM = _veh getVariable ["LastFrameRPM",_redRPM];


	_blowOffToggle = _veh getVariable ["BlowOffToggle",true];

	if (_blowOffToggle AND {_currentRPM < (_lastFrameRPM)} AND (_veh getSoundController "thrust" > 0.3)) then {

		[_veh] spawn GOM_fnc_blowOff;
		_veh setVariable ["BlowOffToggle",false];
	};

	if (_currentRPM > (_lastFrameRPM)) then {

		_veh setVariable ["BlowOffToggle",true];

	};


		_veh setVariable ["LastFrameRPM",_currentRPM];



}];
_ID